DECLARE SUB DELETELINE (x)
DECLARE SUB EDITBOXES (w$, c$)
DECLARE SUB EDITLINE (n$, k$, row, col, leng, updown$, poscol)
DECLARE SUB DORUN (r$, k$)
DECLARE SUB SHOWINSTR (i$())
DECLARE SUB SHOWEDIT (lineno, baseno, fl$)
DECLARE SUB GETNAMES (maxno)
DECLARE SUB SETBATCH (lineno, baseno, fl$)
DECLARE SUB SHOWHELP (lineno, baseno, fl$)
DECLARE SUB FILLMENU (baseno)
DECLARE SUB UPARROW (lineno, baseno)
DECLARE SUB DOWNARROW (lineno, baseno, maxno)
DECLARE SUB DOHELP (h1$, h2$, h3$, h4$, k$)
DECLARE SUB DRAWBOX (ulrow, ulcol, lrrow, lrcol)
DECLARE SUB INSERTLINE (x)
COMMON SHARED edited$, maxno, k, lineno, baseno, cursor, nocursor

' ------
' Get the name of the file which contains the menu information.
' ------

cursor = 1
nocursor = 0

' OPEN "c:\param.mnu" FOR INPUT AS #1
' LINE INPUT #1, fl$
' fl$ = LEFT$(fl$, LEN(fl$) - 1)    ' strip off ending blank
' CLOSE #1

fl$ = COMMAND$
bl% = INSTR(fl$, " ")
IF bl% > 0 THEN
   fl$ = LEFT$(fl$, bl% - 1)
END IF

OPEN fl$ + ".mnu" FOR INPUT AS #1

OPTION BASE 1
DIM ri$(10), ei$(10)
DIM SHARED ci$(10), ai$(5), mi$(7), di$(5), ndi$(5)
ri$(1) = "Use the arrow keys (" + CHR$(24) + " " + CHR$(25) + ") to"
ri$(2) = "highlight the item you want."
ri$(3) = " "
ri$(4) = "Then press the ENTER key."
ri$(5) = " "
ri$(6) = "Press the ESC key to quit."
ri$(7) = " "
ri$(8) = "Use the F2 key to edit"
ri$(9) = "this menu.            "
ri$(10) = " "

ei$(1) = "Press one of the following"
ei$(2) = "keys:"
ei$(3) = " "
ei$(4) = "C - Change highlighted item."
ei$(5) = "D - Delete highlighted item. "
ei$(6) = "A - add an item After"
ei$(7) = "    the highlighted one."
ei$(8) = "B - add an item Before"
ei$(9) = "    the highlighted one."
ei$(10) = "ESC - no more editing."

ci$(1) = "Use the TAB key to move"
ci$(2) = "from box to box."
ci$(3) = " "
ci$(4) = "Press ESC when finished."
ci$(5) = "                    "
ci$(6) = "Enter the entire command"
ci$(7) = "with drive ID and path in"
ci$(8) = "the COMMAND LINE box. "
ci$(9) = "example:               "
ci$(10) = "  C:\sample.exe params"

ai$(1) = "Press M if you want to "
ai$(2) = "add a sub-menu item."
ai$(3) = "Press ESC to exit. "
ai$(4) = "Otherwise press any other"
ai$(5) = "key."

di$(1) = "Press any key if you   "
di$(2) = "are sure that you want"
di$(3) = "to delete this item."
di$(4) = "Otherwise press the ESC  "
di$(5) = "key."

ndi$(1) = "Delete not permitted."
ndi$(2) = "You must have at least"
ndi$(3) = "one item in your menu."
ndi$(4) = " "
ndi$(5) = "Press any key to continue."

mi$(1) = "Use the TAB key to move"
mi$(2) = "from box to box."
mi$(3) = " "
mi$(4) = "Press ESC when finished."
mi$(5) = "                    "
mi$(6) = "Enter the name of the"
mi$(7) = "sub-menu in the MENU box."

baseno = 0
PALETTE 1, 8
PALETTE 6, 7
COLOR 7, 1
CLS
COLOR 0, 7

LINE INPUT #1, A$
WHILE LEFT$(A$, 1) = "*"   ' Skip past comments
  LINE INPUT #1, A$
WEND

maxno = VAL(A$)            ' Number of menu entries to be displayed.
IF maxno < 15 THEN DIMNO = 15:  ELSE DIMNO = maxno
DIM SHARED nam$(DIMNO), rn$(maxno), hlp$(4, maxno)
x = 1
WHILE x <= maxno
  LINE INPUT #1, nam$(x)
  LINE INPUT #1, rn$(x)
  FOR hlp = 1 TO 4
     LINE INPUT #1, hlp$(hlp, x)
  NEXT hlp
  x = x + 1
WEND
CLOSE #1

' if there are fewer than 15 menu items, set up blank items up to 15.
x = maxno + 1
WHILE x < 16
  nam$(x) = " "
  x = x + 1
WEND

' Lay out the menu box
lineno = 1
CALL DRAWBOX(1, 2, 17, 43)
LOCATE 1, 19, nocursor
PRINT "Item Box";

' Put the items in the menu
CALL FILLMENU(baseno)

' Put instructions to the right of the menu
CALL SHOWINSTR(ri$())

c$ = ""
WHILE (c$ = "")   ' do this loop until the program ends
' Show high-lighted item
  COLOR 15, 5
  LOCATE 1 + lineno, 3, nocursor
  x = lineno + baseno
  ln = LEN(nam$(x))
  IF ln < 40 THEN
     PRINT nam$(x); SPACE$(40 - ln)
  ELSEIF ln > 40 THEN
     PRINT LEFT$(nam$(x), 40)
  ELSE
     PRINT nam$(x)
  END IF
  CALL SHOWHELP(lineno, baseno, fl$)
' Get input key - valid keys are:  UP arrow, DOWN arrow, F1, F2, ESC, and ENTER
  LOCATE 24, 1, 0
  k$ = ""
  WHILE k$ = ""
    k$ = INKEY$
  WEND
  IF LEN(k$) = 2 AND ASC(RIGHT$(k$, 1)) = 72 THEN CALL UPARROW(lineno, baseno)
  IF LEN(k$) = 2 AND ASC(RIGHT$(k$, 1)) = 80 THEN CALL DOWNARROW(lineno, baseno, maxno)
  IF LEN(k$) = 2 AND ASC(RIGHT$(k$, 1)) = 59 THEN CALL SHOWHELP(lineno, baseno, fl$)
  IF LEN(k$) = 2 AND ASC(RIGHT$(k$, 1)) = 60 THEN    ' EDIT key (F2)
     PALETTE 6, 27
     CALL SHOWINSTR(ei$())
     CALL SHOWHELP(lineno, baseno, fl$)
     CALL SHOWEDIT(lineno, baseno, fl$)
     PALETTE 6, 7
     CALL SHOWINSTR(ri$())
  END IF
  IF ASC(k$) = 13 THEN                 ' ENTER key
     CALL SETBATCH(lineno, baseno, fl$)
  END IF
  IF ASC(k$) = 27 THEN                 ' ESC key was pressed
     COLOR 7, 0
     CLS
     ON ERROR GOTO outofhere
     KILL fl$ + ".bat"
outofhere:
     SYSTEM
  END IF
WEND

SUB DELETELINE (x)
  
   maxno = maxno - 1
   DIM temprn$(maxno)
   DIM tempnam$(maxno)
   DIM temphlp$(4, maxno)
   FOR i = 1 TO x - 1
     temprn$(i) = rn$(i)
     tempnam$(i) = nam$(i)
     temphlp$(1, i) = hlp$(1, i)
     temphlp$(2, i) = hlp$(2, i)
     temphlp$(3, i) = hlp$(3, i)
     temphlp$(4, i) = hlp$(4, i)
   NEXT i
   FOR i = x TO maxno
     temprn$(i) = rn$(i + 1)
     tempnam$(i) = nam$(i + 1)
     temphlp$(1, i) = hlp$(1, i + 1)
     temphlp$(2, i) = hlp$(2, i + 1)
     temphlp$(3, i) = hlp$(3, i + 1)
     temphlp$(4, i) = hlp$(4, i + 1)
   NEXT i
   IF maxno < 15 THEN DIMNO = 15:  ELSE DIMNO = maxno
   REDIM rn$(maxno), nam$(DIMNO), hlp$(4, maxno)
   FOR i = 1 TO maxno
     rn$(i) = temprn$(i)
     nam$(i) = tempnam$(i)
     hlp$(1, i) = temphlp$(1, i)
     hlp$(2, i) = temphlp$(2, i)
     hlp$(3, i) = temphlp$(3, i)
     hlp$(4, i) = temphlp$(4, i)
   NEXT i
   IF maxno < DIMNO THEN
      nam$(maxno + 1) = " "
   END IF
  
   ERASE temprn$, tempnam$, temphlp$


END SUB

SUB DOWNARROW (lineno, baseno, maxno)
 REM *** DOWN ARROW ROUTINE ***
 COLOR 0, 7
 LOCATE 1 + lineno, 3, nocursor
 x = lineno + baseno
 ln = LEN(nam$(x))
 IF ln < 40 THEN
    PRINT nam$(x); SPACE$(40 - ln)
 ELSEIF ln > 40 THEN
    PRINT LEFT$(nam$(x), 40)
 ELSE
    PRINT nam$(x)
 END IF
 lineno = lineno + 1
 IF lineno > 15 AND lineno + baseno > maxno THEN
    BEEP
    lineno = lineno - 1
    EXIT SUB
 END IF
 IF lineno + baseno > maxno THEN
    BEEP
    lineno = lineno - 1
    EXIT SUB
 END IF
 IF lineno > 15 THEN
    baseno = baseno + 1
    lineno = 15
    CALL FILLMENU(baseno)
 END IF
  
END SUB

SUB DRAWBOX (ulrow, ulcol, lrrow, lrcol)
' Specify upperleft row and column and lower right row and column.

LOCATE ulrow, ulcol, nocursor
box = lrcol - ulcol - 1
PRINT CHR$(201); STRING$(box, 205); CHR$(187);
LOCATE lrrow, ulcol, nocursor
PRINT CHR$(200); STRING$(box, 205); CHR$(188);
FOR i = 1 TO lrrow - ulrow - 1
   LOCATE ulrow + i, ulcol, nocursor
   PRINT CHR$(186); SPACE$(box); CHR$(186);
NEXT i

END SUB

SUB EDITBOXES (w$, c$)
  
   x = lineno + baseno
   done$ = "N"
   COLOR 0, 7
   LOCATE 15, 49, nocursor
   IF w$ = "M" OR w$ = "m" THEN           ' MENU item
      IF c$ = "A" THEN                    ' Adding a menu item
         PRINT LEFT$(rn$(x), INSTR(rn$(x), CHR$(224)) - 1);
      END IF
   ELSE
      PRINT rn$(x);
   END IF

   DO WHILE done$ = "N"
     COLOR 15, 5
     CALL EDITLINE(nam$(x), k$, lineno + 1, 3, 40, "n", 0)
     IF ASC(k$) = 27 THEN
        EXIT DO
     END IF
     COLOR 0, 7
     IF w$ = "M" OR w$ = "m" THEN          'MENU item
        IF c$ = "A" THEN                   ' Adding a menu item
           CALL EDITLINE(rn$(x), k$, 15, 49, 5, "n", 0)
           IF INSTR(rn$(x), CHR$(224)) = 0 THEN
              rn$(x) = rn$(x) + CHR$(224)
           END IF
        END IF
     ELSE
        CALL EDITLINE(rn$(x), k$, 15, 49, 30, "n", 0)
     END IF
     IF ASC(k$) = 27 THEN
        EXIT DO
     END IF
     COLOR 0, 3
     k = 0
     hlp = 1
     col = 2
     WHILE k <> 27 AND k <> 9
      CALL EDITLINE(hlp$(hlp, x), k$, 19 + hlp, 2, 75, "Y", col)
      IF LEN(k$) = 2 THEN
         IF k = 72 THEN               ' up arrow
            hlp = hlp - 1
            IF hlp < 1 THEN hlp = 1
         END IF
         IF k = 80 THEN               ' down arrow
            hlp = hlp + 1
            IF hlp > 4 THEN hlp = 4
         END IF
      END IF
     WEND
     IF ASC(k$) = 27 THEN
        EXIT DO
     END IF
   LOOP

END SUB

SUB EDITLINE (n$, k$, row, col, leng, updown$, poscol)
 
  n$ = n$ + SPACE$(leng - LEN(n$))

  scol = col

  IF poscol > 0 THEN     ' begin with the cursor somewhere other than the beginning of the line.
     col = poscol
  END IF

  k = 0   ' To get by initial check on the do while statement below

  DO WHILE (k <> 27 AND k <> 9)   ' escape or tab key pressed.
     LOCATE row, col, cursor

     k$ = ""
     WHILE k$ = ""
       k$ = INKEY$
     WEND
      
     k = ASC(RIGHT$(k$, 1))
     IF k <> 27 AND k <> 9 THEN
        IF LEN(k$) = 2 THEN
           IF k = 75 THEN           ' Left arrow
              col = col - 1
              IF col < scol THEN col = scol
           ELSEIF k = 77 THEN       ' Right arrow
              col = col + 1
              IF col > scol + leng - 1 THEN col = scol + leng - 1
           ELSEIF k = 72 AND updown$ = "Y" THEN   ' Up arrow
              EXIT DO
           ELSEIF k = 80 AND updown$ = "Y" THEN   ' Down arrow
              EXIT DO
           ELSEIF k = 71 THEN        ' Home key
              col = scol
           ELSEIF k = 79 THEN        ' End key
              col = scol + leng - 1
           END IF
        ELSEIF k > 19 AND k < 127 THEN     ' printable character
           edited$ = "Y"
           MID$(n$, col - scol + 1, 1) = k$
           LOCATE row, col, cursor
           PRINT k$;
           col = col + 1
           IF col > scol + leng - 1 THEN col = scol + leng - 1
        ELSE
           SOUND 100, 5
        END IF
     END IF

  LOOP

  n$ = RTRIM$(n$)
  poscol = col

END SUB

SUB FILLMENU (baseno)
 REM *** Fill the menu area with the names of the games
 x = 1
 WHILE x < 16
   LOCATE 1 + x, 3, nocursor
   ln = LEN(nam$(x + baseno))
   IF ln < 40 THEN
      PRINT nam$(x + baseno); SPACE$(40 - ln)
   ELSEIF ln > 40 THEN
      PRINT LEFT$(nam$(x + baseno), 40)
   ELSE
      PRINT nam$(x + baseno)
   END IF
'   PRINT nam$(x + baseno)
   x = x + 1
 WEND
END SUB

SUB INSERTLINE (x)

   maxno = maxno + 1
   DIM temprn$(maxno)
   DIM tempnam$(maxno)
   DIM temphlp$(4, maxno)
   FOR i = 1 TO x
     temprn$(i) = rn$(i)
     tempnam$(i) = nam$(i)
     temphlp$(1, i) = hlp$(1, i)
     temphlp$(2, i) = hlp$(2, i)
     temphlp$(3, i) = hlp$(3, i)
     temphlp$(4, i) = hlp$(4, i)
   NEXT i
   temprn$(x + 1) = " "
   tempnam$(x + 1) = " "
   temphlp$(1, x + 1) = " "
   temphlp$(2, x + 1) = " "
   temphlp$(3, x + 1) = " "
   temphlp$(4, x + 1) = " "
   FOR i = x + 1 TO maxno - 1
     temprn$(i + 1) = rn$(i)
     tempnam$(i + 1) = nam$(i)
     temphlp$(1, i + 1) = hlp$(1, i)
     temphlp$(2, i + 1) = hlp$(2, i)
     temphlp$(3, i + 1) = hlp$(3, i)
     temphlp$(4, i + 1) = hlp$(4, i)
   NEXT i
   IF maxno < 15 THEN DIMNO = 15:  ELSE DIMNO = maxno
   REDIM rn$(maxno), nam$(DIMNO), hlp$(4, maxno)
   FOR i = 1 TO maxno
     rn$(i) = temprn$(i)
     nam$(i) = tempnam$(i)
     hlp$(1, i) = temphlp$(1, i)
     hlp$(2, i) = temphlp$(2, i)
     hlp$(3, i) = temphlp$(3, i)
     hlp$(4, i) = temphlp$(4, i)
   NEXT i
   ERASE temprn$, tempnam$, temphlp$


END SUB

SUB SETBATCH (lineno, baseno, fl$)
REM  routine creates a batch file called fl$ + .bat which will
REM  be invoked when this BASIC program ends.  This will cause the
REM  selected game to be executed.
  COLOR 7, 4
  drv$ = LEFT$(rn$(lineno + baseno), 2)
  IF UCASE$(drv$) = "C:" OR RIGHT$(drv$, 1) <> ":" THEN
  '   IF drv$ <> "A:" AND drv$ <> "a:" AND drv$ <> "B:" AND drv$ <> "b:" THEN
     rd1$ = " Press a key when ready. "
     rd2$ = " (ESC to cancel action)  "
  ELSE
     rd1$ = "  Place the disk in the  "
     rd2$ = drv$ + " drive and press a key."
  END IF
  LOCATE 14, 50, nocursor
  COLOR 23, 4
  CALL DRAWBOX(14, 49, 17, 76)
  LOCATE 15, 50, nocursor
  COLOR 7, 4
  PRINT rd1$;
  LOCATE 16, 50, nocursor
  PRINT rd2$;
  k$ = ""
  WHILE (k$ = "")
    k$ = INKEY$
  WEND
  IF ASC(k$) = 27 THEN        ' ESC key pressed
     COLOR 1, 1
     CALL DRAWBOX(14, 49, 17, 76)    ' Clear out RED area
     GOTO endofsetbatch
  END IF
  OPEN fl$ + ".bat" FOR OUTPUT AS #3
  IF drv$ = "a:" OR drv$ = "A:" OR drv$ = "b:" OR drv$ = "B:" THEN PRINT #3, drv$
  COLOR 7, 4
  LOCATE 18, 48, nocursor
  IF MID$(rn$(lineno + baseno), 3, 1) = "\" THEN
     rn$(lineno + baseno) = MID$(rn$(lineno + baseno), 4)
  ELSEIF MID$(rn$(lineno + baseno), 2, 1) = ":" THEN
     rn$(lineno + baseno) = MID$(rn$(lineno + baseno), 3)
  END IF
  subdir = INSTR(rn$(lineno + baseno), "\")
  IF subdir <> 0 THEN
     sd$ = "CD \" + MID$(rn$(lineno + baseno), 1, subdir - 1)
     PRINT #3, sd$
     PRINT #3, MID$(rn$(lineno + baseno), subdir + 1)
  ELSE
     IF INSTR(rn$(lineno + baseno), CHR$(224)) > 0 THEN ' This is a sub-menu
        PRINT #3, MID$(rn$(lineno + baseno), 1); ".bat"
     ELSE
        PRINT #3, MID$(rn$(lineno + baseno), 1)
     END IF
  END IF
  PRINT #3, "C:"
  PRINT #3, "CD \"
  CLOSE #3
           
  IF INSTR(rn$(lineno + baseno), CHR$(224)) > 0 THEN   ' This is a sub-menu
     OPEN rn$(lineno + baseno) + ".bat" FOR OUTPUT AS #3
     PRINT #3, ":zmenu"
     PRINT #3, "@echo off"
'     PRINT #3, "echo c:\"; rn$(lineno + baseno); CHR$(224); " >param.mnu"
     PRINT #3, "c:\zzmenu "; rn$(lineno + baseno); CHR$(224)
     PRINT #3, "if exist "; rn$(lineno + baseno); CHR$(224); ".bat call "; rn$(lineno + baseno); CHR$(224); ".bat"
     PRINT #3, "if exist "; rn$(lineno + baseno); CHR$(224); ".bat goto zmenu"
     CLOSE #3
  END IF
 
  COLOR 7, 1
  CLS
  SYSTEM
endofsetbatch:
  k$ = ""
END SUB

SUB SHOWEDIT (lineno, baseno, fl$)

k$ = ""                      ' Determine the type of editing to be done.
WHILE k$ = ""
  k$ = INKEY$
  IF LEN(k$) > 0 THEN
     IF INSTR("ABCDabcd", k$) = 0 AND ASC(k$) <> 27 THEN
        SOUND 100, 5
        k$ = ""
     END IF
  END IF
WEND

IF ASC(k$) = 27 THEN          ' ESC key pressed
   EXIT SUB
END IF

edited$ = "N"
PALETTE 6, 37

COLOR 0, 7
IF k$ = "A" OR k$ = "a" OR k$ = "B" OR k$ = "b" THEN
  
   CALL SHOWINSTR(ai$())        ' Determine whether a menu or program is
   COLOR 0, 7                   ' being added.
   w$ = ""
   WHILE w$ = ""
     w$ = INKEY$
   WEND
   IF ASC(w$) = 27 THEN    'ESC key
      EXIT SUB
   END IF
  
   IF k$ = "a" OR k$ = "A" THEN               ' Adding item after current one
      CALL INSERTLINE(lineno + baseno)
      CALL FILLMENU(baseno)
      CALL DOWNARROW(lineno, baseno, maxno)
   ELSE                                       ' Adding item before current one
      CALL INSERTLINE(lineno + baseno - 1)
      CALL FILLMENU(baseno)
   END IF
  
   COLOR 15, 5
   LOCATE lineno + 1, 3, nocursor
   PRINT SPACE$(40);
   CALL SHOWHELP(lineno, baseno, fl$)
   COLOR 0, 7
  
   IF w$ = "M" OR w$ = "m" THEN               ' A MENU item is being added
      CALL DRAWBOX(14, 48, 16, 54)
      LOCATE 14, 49, nocursor
      PRINT "Menu";
      CALL SHOWINSTR(mi$())
      rn$(lineno + baseno) = rn$(lineno + baseno) + CHR$(224)
      CALL EDITBOXES(w$, "A")
      IF edited$ = "Y" THEN      ' create a model to be edited.
         OPEN rn$(lineno + baseno) + CHR$(224) + ".mnu" FOR OUTPUT AS #1
         PRINT #1, "1"                 ' 1 item in the menu
         PRINT #1, "Sample item name"
         PRINT #1, "C:\SAMPLE.EXE"
         PRINT #1, "Sample help area - line 1 - change this to be something you want."
         PRINT #1, "                   line 2"
         PRINT #1, "                   line 3"
         PRINT #1, "                   line 4"
         CLOSE #1
      END IF
   ELSE                                      ' A program item is being added
      CALL DRAWBOX(14, 48, 16, 79)
      LOCATE 14, 55, nocursor
      PRINT "Command Box";
      CALL SHOWINSTR(ci$())
      CALL EDITBOXES(w$, "A")
   END IF
END IF

IF k$ = "C" OR k$ = "c" THEN

   x = lineno + baseno
   m = INSTR(rn$(x), CHR$(224))
  
   IF m > 0 THEN                         ' A MENU item is being changed
'      CALL DRAWBOX(14, 48, 16, 54)
'      LOCATE 14, 49, nocursor
'      PRINT "Menu";
      CALL SHOWINSTR(mi$())
      CALL EDITBOXES("M", "C")

   ELSE                                   ' A program item is being changed
      CALL DRAWBOX(14, 48, 16, 79)
      LOCATE 14, 55, nocursor
      PRINT "Command Box";
      CALL SHOWINSTR(ci$())
      CALL EDITBOXES(" ", "C")
   END IF
  

END IF

IF k$ = "D" OR k$ = "d" THEN
   IF maxno = 1 THEN
      CALL SHOWINSTR(ndi$())
      WHILE INKEY$ = ""
      WEND
      EXIT SUB
   END IF
   CALL SHOWINSTR(di$())
   COLOR 0, 7
   w$ = ""
   WHILE w$ = ""
     w$ = INKEY$
   WEND
   IF ASC(w$) = 27 THEN    'ESC key
      EXIT SUB
   END IF
   CALL DELETELINE(lineno + baseno)
   IF lineno + baseno > maxno THEN
      CALL UPARROW(lineno, baseno)
   END IF
   edited$ = "Y"
   CALL FILLMENU(baseno)
END IF

IF edited$ = "Y" THEN
   OPEN fl$ + ".mnu" FOR OUTPUT AS #1
   PRINT #1, STR$(maxno)
   FOR i = 1 TO maxno
     PRINT #1, nam$(i)
     PRINT #1, rn$(i)
     FOR hlp = 1 TO 4
       PRINT #1, hlp$(hlp, i)
     NEXT hlp
   NEXT i
   CLOSE #1

END IF


COLOR 1, 1
CALL DRAWBOX(14, 48, 16, 79)


END SUB

SUB SHOWHELP (lineno, baseno, fl$)
 REM *** Show help screen information for the current item ***
 COLOR 0, 3
 CALL DRAWBOX(19, 1, 24, 77)
 LOCATE 19, 32, nocursor
 PRINT "Information Box";
 FOR hlp = 1 TO 4
    x = lineno + baseno
    DESCR$ = hlp$(hlp, x)
    IF LEFT$(DESCR$, 2) = "!!" THEN
       hilite$ = "Y"
'       DESCR$ = MID$(DESCR$, 3)
    ELSE
       hilite$ = "N"
    END IF
    LOCATE 20 + hlp - 1, 2, nocursor
    IF hilite$ = "Y" THEN
       COLOR 7, 4
    ELSE
       COLOR 0, 3
    END IF
    ln = LEN(DESCR$)
    IF ln < 75 THEN
       PRINT DESCR$; SPACE$(75 - ln);
    ELSEIF ln > 75 THEN
       PRINT LEFT$(DESCR$, 75);
    ELSE
       PRINT DESCR$;
    END IF
    COLOR 0, 3
 NEXT hlp
END SUB

SUB SHOWINSTR (i$())
 
  COLOR 1, 6
  CALL DRAWBOX(1, 48, 12, 79)
  LOCATE 1, 58, nocursor
  PRINT "Instructions";
 
  FOR i = LBOUND(i$, 1) TO UBOUND(i$, 1)
    LOCATE i + 1, 50, nocursor
    PRINT i$(i)
  NEXT i

END SUB

SUB UPARROW (lineno, baseno)
 REM *** UP arrow routine ***
 COLOR 0, 7
 LOCATE 1 + lineno, 3, nocursor
 x = lineno + baseno
 ln = LEN(nam$(x))
 IF ln < 40 THEN
    PRINT nam$(x); SPACE$(40 - ln)
 ELSEIF ln > 40 THEN
    PRINT LEFT$(nam$(x), 40)
 ELSE
    PRINT nam$(x)
 END IF
'  PRINT nam$(lineno + baseno)
 lineno = lineno - 1
 IF lineno < 1 AND baseno = 0 THEN
    BEEP
    lineno = lineno + 1
    GOTO endit
 END IF
 IF lineno < 1 THEN
    baseno = baseno - 1
    lineno = 1
    CALL FILLMENU(baseno)
 END IF
endit:
END SUB

